/* $Header:   K:/man/ws.c_v   1.0   08 Nov 1993 10:10:44   milow  $ */
/*
 *
 *                     Copyright 1991 Starbase Corp.
 *                        All rights reserved
 *
 *    This source code is provided to the purchaser of the product
 *    for the purpose of allowing the purchaser to customize and/or
 *    extend the functionality of the product.  The source code   
 *    remains the property of Starbase Corp. with all rights reserved.
 *    Any modifications to the source code are considered derivative
 *    works and all rights thereto are reserved to Starbase Corp. except
 *    that the purchaser may use the modified product in the same
 *    permitted manner as the unmodified product.  It is expressly
 *    prohibited to distribute in any manner any part of the original
 *    source code, whether in source or object form, without the
 *    express written permission from Starbase Corp.
 *
 *    Owner:
 *        Starbase Corporation
 *        1075 NW Murray Blvd., Suite 268
 *        Portland OR 97229
 *
 */					
#include <windows.h>
#include <string.h>
#include <ctype.h>
#include <exports.h>
#include <stdlib.h>
#include "cwstart.h"


LIBMAIN    /* defines the LibMain() function for Borland C */

static HKEYMAP wsKmap = 0;

static WS_block_type = SELECTION_EXCLUSIVE;

void DLL ws()
{
	MsgMessage("Loading WordStar Keymap...");

	if (!wsKmap || !KmapQIsValidHandle( wsKmap ))
	{

		SysCaretHeight( -25, CARET_INSERT );
		SysCaretHeight( -50, CARET_INSERT_VIRTUAL );
		SysCaretHeight( 100, CARET_OVERTYPE );
		SysCaretHeight(  50, CARET_OVERTYPE_VIRTUAL );
		SysCaretWidth( 100 );

		SrchSetFlags( SEARCH_FORWARD|SEARCH_SELECTION );

		SysSetFlags((SysQFlags() & ~( SYSFLAG_TRAP_SYS_KEYS))
			| (SYSFLAG_STATE_ENABLED 
			| SYSFLAG_CMND_LINE_PROMPT 
			| SYSFLAG_MOUSE_WIN_CREATE 
			| SYSFLAG_NEW_WIN_FOR_BUF 
			| SYSFLAG_RETAIN_DIR 
			| SYSFLAG_CONFIG_UPDATE 
			| SYSFLAG_IBEAM_CURSOR 
			| SYSFLAG_SHOW_RIBBON 
			| SYSFLAG_CLIPBOARD));
			
		SysSetDefault( DEFAULT_WINDOW_SYSFLAGS,
			SysQDefault(DEFAULT_WINDOW_SYSFLAGS) | WINDOW_VSCROLLBAR );


		wsKmap = KmapCreate("WordStar");
		KmapSetCurrent(wsKmap);


		AssignMouseKeys();
		KmapAssign( "<mouse_left_down>",         "MouseLeftDown SELECTION_EXCLUSIVE 0 1" );
		KmapAssign( "<mouse_right_down>",        "MouseRightDown" );
		KmapAssign( "<Ctrl-mouse_right_click>",  "MouseCopyMove 1");
		KmapAssign( "<Ctrl-Shift-mouse_right_click>", "MouseCopyMove 0");

	    KmapAssignTypeables();

		KmapAssignRange( KEY_ASCII_CODE, KEY_ASCII_CODE | 255, "BufInsertChar" );

		KmapAssignRange( KEY_CTRL_CODE | KEY_ALT_CODE | 48, 
			KEY_CTRL_CODE | KEY_ALT_CODE | 57, "BufInsertChar" );

		KmapAssign( "<Alt-Backspace>",   "Undo"                 );  
		KmapAssign( "<Alt-F9>",          "ExecCompile"          );  
		KmapAssign( "<Alt-Insert>",      "Redo"                 );  
		KmapAssign( "<Backspace>",       "BufBackspace"         );  
		KmapAssign( "#328",              "BufBackspace"         );  
		KmapAssign( "<Ctrl-A>",          "WS_prev_word"         );  
		KmapAssign( "<Ctrl-B>",          "WrapParagraph"        );  
		KmapAssign( "<Ctrl-Backspace>",  "delete_prev_word"     );  
		KmapAssign( "<Ctrl-C>",          "MovPageDown"          );  
		KmapAssign( "<Ctrl-D>",          "MovRight"             );  
		KmapAssign( "<Ctrl-E>",          "MovUp"                );  
		KmapAssign( "<Ctrl-F1>",         "CWHelp"               );  
		KmapAssign( "<Ctrl-F9>",         "WS_exec_run"          );  
		KmapAssign( "<Ctrl-F>",          "WS_next_word"         );  
		KmapAssign( "<Ctrl-G>",          "WS_delete_chars"      );  
		KmapAssign( "<Ctrl-I>",          "Redo"                 );  
		KmapAssign( "<Ctrl-Insert>",     "BufInsertScrap"       );  
		KmapAssign( "<Ctrl-K>0",         "WS_drop_bookmark      10"  );     
		KmapAssign( "<Ctrl-K>1",         "WS_drop_bookmark      1"   );     
		KmapAssign( "<Ctrl-K>2",         "WS_drop_bookmark      2"   );     
		KmapAssign( "<Ctrl-K>3",         "WS_drop_bookmark      3"   );     
		KmapAssign( "<Ctrl-K>4",         "WS_drop_bookmark      4"   );     
		KmapAssign( "<Ctrl-K>5",         "WS_drop_bookmark      5"   );     
		KmapAssign( "<Ctrl-K>6",         "WS_drop_bookmark      6"   );     
		KmapAssign( "<Ctrl-K>7",         "WS_drop_bookmark      7"   );     
		KmapAssign( "<Ctrl-K>8",         "WS_drop_bookmark      8"   );     
		KmapAssign( "<Ctrl-K>9",         "WS_drop_bookmark      9"   );     
		KmapAssign( "<Ctrl-K><Ctrl-B>",  "WS_begin_block"       );  
		KmapAssign( "<Ctrl-K><Ctrl-C>",  "WS_copy_move          0"   );     
		KmapAssign( "<Ctrl-K><Ctrl-H>",  "WS_hide_block"        );  
		KmapAssign( "<Ctrl-K><Ctrl-K>",  "WS_end_block"         );  
		KmapAssign( "<Ctrl-K><Ctrl-N>",  "WS_toggle_block_type" );  
		KmapAssign( "<Ctrl-K><Ctrl-V>",  "WS_copy_move          1"   );     
		KmapAssign( "<Ctrl-K><Ctrl-W>",  "WriteBuffer"          );  
		KmapAssign( "<Ctrl-K><Ctrl-Y>",  "BufDelSelection"      );  
		KmapAssign( "<Ctrl-K>b",         "WS_begin_block"       );  
		KmapAssign( "<Ctrl-K>B",         "WS_begin_block"       );  
		KmapAssign( "<Ctrl-K>c",         "WS_copy_move          0"   );     
		KmapAssign( "<Ctrl-K>C",         "WS_copy_move          0"   );     
		KmapAssign( "<Ctrl-K>h",         "WS_hide_block"        );  
		KmapAssign( "<Ctrl-K>H",         "WS_hide_block"        );  
		KmapAssign( "<Ctrl-K>k",         "WS_end_block"         );  
		KmapAssign( "<Ctrl-K>K",         "WS_end_block"         );  
		KmapAssign( "<Ctrl-K>n",         "WS_toggle_block_type" );  
		KmapAssign( "<Ctrl-K>N",         "WS_toggle_block_type" );  
		KmapAssign( "<Ctrl-K>v",         "WS_copy_move          1"   );     
		KmapAssign( "<Ctrl-K>V",         "WS_copy_move          1"   );     
		KmapAssign( "<Ctrl-K>w",         "WriteBuffer"          );  
		KmapAssign( "<Ctrl-K>W",         "WriteBuffer"          );  
		KmapAssign( "<Ctrl-K>Y",         "BufDelSelection"      );  
		KmapAssign( "<Ctrl-K>y",         "BufDelSelection"      );  
		KmapAssign( "<Ctrl-L>",          "srchCommand           0    0x1206" );
		KmapAssign( "<Ctrl-left>",       "WS_prev_word"         );  
		KmapAssign( "<Ctrl-N>",          "WS_open_line"         );  
		KmapAssign( "<Ctrl-O><Ctrl-L>",  "WS_set_lmargin"       );  
		KmapAssign( "<Ctrl-O><Ctrl-R>",  "WS_set_rmargin"       );  
		KmapAssign( "<Ctrl-O><Ctrl-W>",  "WS_toggle_wrap"       );  
		KmapAssign( "<Ctrl-O>L",         "WS_set_lmargin"       );  
		KmapAssign( "<Ctrl-O>l",         "WS_set_lmargin"       );  
		KmapAssign( "<Ctrl-O>R",         "WS_set_rmargin"       );  
		KmapAssign( "<Ctrl-O>r",         "WS_set_rmargin"       );  
		KmapAssign( "<Ctrl-O>W",         "WS_toggle_wrap"       );  
		KmapAssign( "<Ctrl-O>w",         "WS_toggle_wrap"       );  
		KmapAssign( "<Ctrl-Pagedown>",   "WS_end_of_file"       );  
		KmapAssign( "<Ctrl-Pageup>",     "WS_beg_of_file"       );  
		KmapAssign( "<Ctrl-Q>0",         "WS_goto_bookmark      10"  );     
		KmapAssign( "<Ctrl-Q>1",         "WS_goto_bookmark      1"   );     
		KmapAssign( "<Ctrl-Q>2",         "WS_goto_bookmark      2"   );     
		KmapAssign( "<Ctrl-Q>3",         "WS_goto_bookmark      3"   );     
		KmapAssign( "<Ctrl-Q>4",         "WS_goto_bookmark      4"   );     
		KmapAssign( "<Ctrl-Q>5",         "WS_goto_bookmark      5"   );     
		KmapAssign( "<Ctrl-Q>6",         "WS_goto_bookmark      6"   );     
		KmapAssign( "<Ctrl-Q>7",         "WS_goto_bookmark      7"   );     
		KmapAssign( "<Ctrl-Q>8",         "WS_goto_bookmark      8"   );     
		KmapAssign( "<Ctrl-Q>9",         "WS_goto_bookmark      9"   );     
		KmapAssign( "<Ctrl-Q><Ctrl-A>",  "srchCommand           0    0x1203" );
		KmapAssign( "<Ctrl-Q><Ctrl-C>",  "WS_end_of_file"       );  
		KmapAssign( "<Ctrl-Q><Ctrl-D>",  "MovEOL"               );  
		KmapAssign( "<Ctrl-Q><Ctrl-F>",  "srchCommand           0    0x1205" );
		KmapAssign( "<Ctrl-Q><Ctrl-I>",  "DlgMarkGotoLine"      );  
		KmapAssign( "<Ctrl-Q><Ctrl-R>",  "WS_beg_of_file"       );  
		KmapAssign( "<Ctrl-Q><Ctrl-S>",  "BufDelToEOL"          );  
		KmapAssign( "<Ctrl-Q><Ctrl-Y>",  "BufDelToEOL"          );  
		KmapAssign( "<Ctrl-Q>a",         "srchCommand           0    0x1203" );
		KmapAssign( "<Ctrl-Q>A",         "srchCommand           0    0x1203" );
		KmapAssign( "<Ctrl-Q>c",         "WS_end_of_file"       );  
		KmapAssign( "<Ctrl-Q>C",         "WS_end_of_file"       );  
		KmapAssign( "<Ctrl-Q>d",         "MovEOL"               );  
		KmapAssign( "<Ctrl-Q>D",         "MovEOL"               );  
		KmapAssign( "<Ctrl-Q>f",         "srchCommand           0    0x1205" );
		KmapAssign( "<Ctrl-Q>F",         "srchCommand           0    0x1205" );
		KmapAssign( "<Ctrl-Q>i",         "DlgMarkGotoLine"      );  
		KmapAssign( "<Ctrl-Q>I",         "DlgMarkGotoLine"      );  
		KmapAssign( "<Ctrl-Q>r",         "WS_beg_of_file"       );  
		KmapAssign( "<Ctrl-Q>R",         "WS_beg_of_file"       );  
		KmapAssign( "<Ctrl-Q>s",         "MovHome"              );  
		KmapAssign( "<Ctrl-Q>y",         "BufDelToEOL"          );  
		KmapAssign( "<Ctrl-Q>Y",         "BufDelToEOL"          );  
		KmapAssign( "<Ctrl-R>",          "MovPageUp"            );  
		KmapAssign( "<Ctrl-right>",      "WS_next_word"         );  
		KmapAssign( "<Ctrl-S>",          "MovLeft"              );  
		KmapAssign( "<Ctrl-Shift-C>",    "BufSetCompact"        );  
		KmapAssign( "<Ctrl-Shift-H>",    "BufSetHexBinary"      );  
		KmapAssign( "<Ctrl-Shift-T>",    "BufSetAscii"          );  
		KmapAssign( "<Ctrl-T>",          "deleteNextWord"       );  
		KmapAssign( "<Ctrl-U>",          "Undo"                 );  
		KmapAssign( "<Ctrl-V>",          "InsertMode"           );  
		KmapAssign( "<Ctrl-W>",          "WinScrollV            1"   );     
		KmapAssign( "<Ctrl-X>",          "MovDown"              );  
		KmapAssign( "<Ctrl-Y>",          "BufDelLine            1"   );     
		KmapAssign( "<Ctrl-Z>",          "WinScrollV            -1"  );     
		KmapAssign( "<Del>",             "WS_delete_chars"      );  
		KmapAssign( "<down>",            "MovDown"              );  
		KmapAssign( "<End>",             "MovEOL"               );  
		KmapAssign( "<Enter>",           "BufInsertEOL"         );  
		KmapAssign( "<F2>",              "WS_save"              );  
		KmapAssign( "<F3>",              "DlgOpenFile           0");
		KmapAssign( "<F9>",              "ExecMake"             );  
		KmapAssign( "<Home>",            "MovHome"              );  
		KmapAssign( "<left>",            "MovLeft"              );  
		KmapAssign( "<Pagedown>",        "MovPageDown"          );  
		KmapAssign( "<Pageup>",          "MovPageUp"            );  
		KmapAssign( "<right>",           "MovRight"             );  
		KmapAssign( "<Shift-Backspace>", "BufBackspace"         );  
		KmapAssign( "<Shift-Del>",       "BufCutToScrap"        );  
		KmapAssign( "<Shift-F10>",       "ExecuteMacro"         );  
		KmapAssign( "<Shift-Insert>",    "Paste"                );  
		KmapAssign( "<Shift-Space>",     "BufInsertChar         32"  );     
		KmapAssign( "<Space>",           "Space"                );  
		KmapAssign( "<Tab>",             "Tab"                  );  
		KmapAssign( "<up>",              "MovUp"                );  

	}
	else
	{
		/* The keymap had already been created, just make it current.
		 */
		KmapSetCurrent( wsKmap );
	}

	MsgMessage("WordStar command set in effect.");
}

void DLL ws32()
{
	ws();
}

void DLL cwvws32()
{
	ws();
}

void DLL cwvws()
{
	ws();
}

void DLL WS_save()  
{
	if (BufQModified() > 0)
	{
		MsgMessage("Saving file...");
		if (BufWrite() == 0)
			MsgMessage("File saved.");
		else
			MsgMessage("Error writing file.");
	}
}

void DLL WS_next_word()
{
	NextWord();
}


void DLL WS_prev_word()	  
{
	PrevWord();
}

void DLL WS_delete_chars() 
{
	if (MarkQSelType() == SELECTION_NONE)
		BufDelChar( 1 );
	else
		BufDelSelection();
}	

void DLL WS_begin_block()  
{
	int TestType = MarkQSelType();

	if (TestType > 0)
	{
		if (TestType == WS_block_type)
		{
			MarkSet(MarkQSelBeginID(),BufQCurrentLine(),BufQCurrentCol());
		}
		else
			MarkRemoveSel();
	}
	else
		MarkBeginSel(WS_block_type);
}

void DLL WS_end_block()  
{
	if (MarkQSelType() > 0)
	{
		if (MarkQIsSelOpen() == 0)
		{
			MarkSet(MarkQSelEndID(),BufQCurrentLine(),BufQCurrentCol());
		}
		else
			MarkEndSel();
	}
	else
		MsgWarning("No selection defined.");
}

void DLL WS_copy_move(int moveIt )
{
	if (MarkQSelType() > 0)
	{
		if (moveIt != 0)
			BufCutToScrap();
		else
			BufCopyToScrap();
		BufInsertScrap();
	}
	else
		MsgWarning("No selection defined.");
}

LPSTR DLL BufferName()
{
     if (BufQOutputName() == NIL)
        return BufQFilename();
     else
         return BufQOutputName();
}

void DLL WS_end_of_file()  
{
	MovEOF();
	MovEOL();
}

void DLL WS_beg_of_file()  
{
	MovTopBuf();
	MovHome();
}
		
void DLL WS_exec_run() 
{
	SysExec(TransformFilename(BufferName(),"%b"),"",0);	 
}

void DLL WS_open_line() 
{
	MarkSavePos();
	BufInsertEOL();
	MarkRestorePos();
}

void DLL
WS_drop_bookmark( int num )
{
	int ch;
	if (num == 0)
		num = 10;

	if (MarkQInUse( MARK_GLOBAL | num ))
	{
		ch = MsgConfirm( "Overwrite existing bookmark (Y/N)? ", "yYnN" );

		/* The mark has already been used once, see if the user wishes
		 * to overwrite it.
		 */

		if (ch != 'Y' && ch != 'y')
		{
			MsgMessage( "Command cancelled." );
			return;
		}
	}

	if (MarkCreateGlobal( num ) )
		MsgMessage( "Bookmark dropped." );
}

void DLL WS_goto_bookmark( int num )
{
	MarkGoto(MARK_GLOBAL | num);
}

void DLL WS_toggle_wrap()
{
	if ( WrapEnable(-1) )
	{
		WrapEnable( 0 );
		MsgMessage("Word wrap OFF");
	}
	else
	{
		WrapEnable( 2 );
		MsgMessage("Word wrap ON");
	}
}
 
void DLL WS_set_rmargin()
{
	LPSTR margin;
	int mVal;

	margin = MsgPromptHistory("RMARGIN","New right margin setting: ","70");
	if (margin)
	{
		mVal = atoi( margin );
		if ( mVal >= 0 )
		{
			WinVisibleMarginColumn( mVal );
			MsgPrintf(0,"Right margin set to %d",mVal);
		}
	}
}

void DLL WS_set_lmargin()
{
	LPSTR margin;
	int mVal;

	margin = MsgPromptHistory("RMARGIN","New left margin setting: ","10");
	if (margin)
	{
		mVal = atoi( margin );
		if ( mVal >= 0 )
		{
			WinLeftMargin( mVal );
			MsgPrintf(0,"Left margin set to %d",mVal);
		}
	}
}

void DLL WS_toggle_block_type()
{
	if (WS_block_type == SELECTION_EXCLUSIVE)
	{
		WS_block_type = SELECTION_COLUMN;
		MsgMessage("Column selection mode ON.");
	}
	else
	{
		WS_block_type = SELECTION_EXCLUSIVE;
		MsgMessage("Column selection mode OFF.");
	}
}


static	Selection last_sel = {0};

void DLL WS_hide_block()
{
	MarkID saved_pos;

	if ( MarkQSelType() )
	{
		if ( !MarkQIsSelOpen() )
		{
			MarkGetSelInfo(&last_sel,!(MarkQSelType() & SELECTION_EXCLUSIVE));
			MarkRemoveAllSel();
			MsgMessage("Block hidden.");
		}
		else
			MsgWarning("Block not closed.");
	}
	else
	{
		if (last_sel.selType)
		{
			saved_pos = MarkAllocGlobal();
			BufSetCurrentBuffer(last_sel.hBuffer);
			MovAbs(last_sel.begin.line,	last_sel.begin.column);
			MarkBeginSel(last_sel.selType);
			MovAbs(last_sel.end.line,	last_sel.end.column);
			MarkEndSel();
			MarkGoto(saved_pos);
			MarkFree(saved_pos);
			MsgMessage("Block revealed.");
		}
		else
			MsgWarning("No hidden block defined.");
	}
}

void DLL _init() 
{
	LibExport("cwvws");
	LibExport("ws32");
	LibExport("cwvws32");
	LibExport("ws");
	LibExport("WS_hide_block");
	LibExport("WS_toggle_block_type");
	LibExport("WS_toggle_wrap");
	LibExport("WS_set_rmargin");
	LibExport("WS_set_lmargin");
	LibExport("WS_next_word");			  
	LibExport("WS_prev_word");
	LibExport("WS_begin_block");
	LibExport("WS_end_block");
	LibExport("WS_end_of_file");
	LibExport("WS_beg_of_file");
	LibExport("WS_copy_move int");
	LibExport("WS_save");
	LibExport("WS_delete_chars");
	LibExport("WS_exec_run");
	LibExport("WS_open_line");
	LibExport("WS_goto_bookmark int");
	LibExport("WS_drop_bookmark int");

}

